"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const ts_simple_ast_1 = __importDefault(require("ts-simple-ast"));
/** gets the config file of given ts project or undefined if given is not a ConfiguredProject or tsconfig cannot be found */
function getConfigFilePath(project) {
    if (project.getConfigFilePath) {
        return project.getConfigFilePath();
    }
    else { // workaround - probably this project is not configured
        return project.getFileNames().find(p => path_1.basename(p.toString()) === 'tsconfig.json');
    }
    // TODO: for integrate it in simple-ast try with findConfigFile
}
/**
 * (dirty way) of creating a ts-simple-ast Project from an exiting ts.server.Project. Given project must be a
 * configured project (created with a tsconfig file. It will recreates the project from scratch so it can take
 * some time. Use it with discretion
 */
function createSimpleASTProject(nativeProject) {
    const project = new ts_simple_ast_1.default({
        tsConfigFilePath: getConfigFilePath(nativeProject)
    });
    // simpleASTProjectCache[tsConfigFilePath] = {configFile: tsConfigFilePath, sourceFileMDates: {}}
    return project;
}
exports.createSimpleASTProject = createSimpleASTProject;
// export interface SimpleASTProjectCacheValue {
//   configFile: string, 
//   sourceFileMDates: {[sourceFilePath:string]: number}
// }
// const simpleASTProjectCache: {[tsConfigFilePath:string]: {configFile: string, sourceFileMDates: {[sourceFilePath: string]: number} }} = {}
// function takeMtimeSimpleASTProject(project: Project){
// // project.getCompilerOptions().project.co
// }
// // export function refreshSimpleASTProject
// export function  refreshSimpleASTProject(project: Project, nativeProject: ts_module.server.Project){
//   //TODO: check new sourcefile dates (or content hash ? ) and for those sourcefiles which changed refresh!  also  ḧow to solve the problem of new files - deleted files ? 
// }
// //TODO: 
//# sourceMappingURL=ts-simple-ast-util.js.map